unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Contnrs, AppEvnts, Buttons, ImgList;

type

  TForm1 = class(TForm)
    Timer1: TTimer;
    ApplicationEvents1: TApplicationEvents;
    Panel2: TPanel;
    Button1: TButton;
    Panel3: TPanel;
    Label1: TLabel;
    PB: TImage;
    Label2: TLabel;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ApplicationEvents1Message(var Msg: tagMSG;
      var Handled: Boolean);
  private
    { Dclarations prives }
  public
    isGameOver: boolean;
  end;

  TSerpent = class;

  TOrientation = (toUp, toLeft, toRight, toDown);

  TGameManager = class(TPersistent)
  private
  protected
  public
    constructor Create;
    destructor destroy;override;
    procedure Start;
    procedure Stop;
    procedure Pause;
  end;

  TEntityManager = class(TPersistent)
  private
   FEntity: TObjectList;
   FCount: Integer;
  protected
  public
    constructor Create;
    destructor Destroy; override;
    function Add(AObject: TObject): Integer;
    function DoCollision(Serpent: TSerpent):boolean;
  end;

  PPoint = ^TPoint;

  TSerpent = class(TPersistent)
  private
    FPosition: TPoint;
    FWidth: Byte;
    FHeight: Byte;
    FKey: TOrientation;
   // FPrecKey: TOrientation;
    FColor: TColor;
    FSize: Cardinal;
    FItems: TList;
    FCompteur: Byte;
    procedure SetPosition(const Value: TPoint);
    procedure SetSize(const Value: Cardinal);
  protected
  public
    procedure Move(orientation: TOrientation);
    constructor Create;
    destructor Destroy; override;
    procedure Draw(Canvas: TCanvas);
  property  Position: TPoint read FPosition write SetPosition;
  property  Size: Cardinal read FSize write SetSize;
  end;

  TFrog = class(TPersistent)
  private
    Fposition: TPoint;
    FColor: TColor;
    FWidth: Byte;
    FHeight: Byte;
    procedure Setposition(const Value: TPoint);
  protected
  public
    constructor Create();
    destructor destroy;override;
    procedure Draw(Canvas: TCanvas);
    procedure Move;
  property position: TPoint read Fposition write Setposition;
  end;


var
  Form1: TForm1;
  Serpent: TSerpent;
  Frog: TFrog;
  EntityManager: TEntityManager;
  Counter: Integer;
  GameManager: TGameManager;

implementation

{$R *.DFM}

{ TSerpent }

constructor TSerpent.Create;
var I: Integer;
    PPt: PPoint;
begin
  inherited;
  FHeight := 10;
  FWidth := 10;
  FColor := $49C265;
  FSize := 2;
  FPosition.x := 150;
  FPosition.y := 150;
  FCompteur :=0;
  FItems := TList.Create;
  For I := 1 to Self.FSize do
  begin
    New(PPt);
    PPt^.x :=  FPosition.x;
    PPt^.y :=  10 * I + FPosition.y;
    FItems.Add(PPt);
  end;
end;

destructor TSerpent.Destroy;
var
  PPt :PPoint;
  I: Integer;
begin
  for I := 0 to (FItems.Count - 1) do
  begin
    PPt := PPoint(Fitems.Items[I]);
    Dispose(PPt);
  end;
  FItems.Free;
end;

procedure TSerpent.Draw(Canvas: TCanvas);
var I: Integer;
    ImgIndx: Byte;
begin
  Canvas.Brush.Color := Self.FColor;
  for I := 1 to FItems.Count -1 do
  begin
    Canvas.FillRect(Bounds(PPoint(FItems[i])^.x, PPoint(FItems[i])^.Y, 10, 10));
  end;
  if PPoint(FItems[0])^.x = PPoint(FItems[1])^.x+10 then ImgIndx := 3;
  if PPoint(FItems[0])^.x = PPoint(FItems[1])^.x-10 then ImgIndx := 2;
  if PPoint(FItems[0])^.y = PPoint(FItems[1])^.y+10 then ImgIndx := 1;
  if PPoint(FItems[0])^.y = PPoint(FItems[1])^.y-10 then ImgIndx := 0;
  Form1.ImageList1.Draw(Canvas,PPoint(FItems[0])^.x-5, PPoint(FItems[0])^.Y-7, ImgIndx);
end;



procedure TSerpent.Move(orientation: TOrientation);
var PPt: PPoint;
begin
  With Serpent do
  begin
    case Orientation of
      toLeft:
        begin
          New(PPt);
          PPt^.x := PPoint(FItems[0])^.x -10;
          PPt^.y := PPoint(FItems[0])^.y;
          FItems.Insert(0, PPt);
          Serpent.Position := PPt^;
          if  Serpent.FCompteur <= 0 then
            FItems.Remove(PPoint(FItems.Last))
          else
          begin
            //Serpent.SetSize(FItems.Count-1);
            Dec(Serpent.FCompteur);
          end;
        end;
      toUp:
        begin
          New(PPt);
          PPt^.x := PPoint(FItems[0])^.x;
          PPt^.y := PPoint(FItems[0])^.y -10;
          FItems.Insert(0, PPt);
          Serpent.Position := PPt^;
          if  Serpent.FCompteur = 0 then
            FItems.Remove(PPoint(FItems.Last))
          else
          begin
           // Serpent.SetSize(FItems.Count);
            Dec(Serpent.FCompteur);
          end;
        end;
      toRight:
        begin
          New(PPt);
          PPt^.x := PPoint(FItems[0])^.x +10;
          PPt^.y := PPoint(FItems[0])^.y;
          FItems.Insert(0, PPt);
          Serpent.Position := PPt^;
          if  Serpent.FCompteur = 0 then
            FItems.Remove(PPoint(FItems.Last))
          else
          begin
           // Serpent.SetSize(FItems.Count);
            Dec(Serpent.FCompteur);
          end;
        end;
      toDown:
        begin
          New(PPt);
          PPt^.x := PPoint(FItems[0])^.x;
          PPt^.y := PPoint(FItems[0])^.y + 10;
          FItems.Insert(0, PPt);
          Serpent.Position := PPt^;
          if  Serpent.FCompteur = 0 then
            FItems.Remove(PPoint(FItems.Last))
          else
          begin
           // Serpent.SetSize(FItems.Count);
            Dec(Serpent.FCompteur);
          end;
        end;
    end;
  end;
end;

procedure TSerpent.SetPosition(const Value: TPoint);
begin
  FPosition := Value;
end;

procedure TSerpent.SetSize(const Value: Cardinal);
begin
  FSize := Value;
end;


Procedure ClearPB(Canvas: TCanvas; Color: TColor; Rec:TRect);
begin
  Canvas.Brush.Color := Color;
  Canvas.FillRect(Rec);
end;

{ TFROG -----------------------------------------------------------------------}

constructor TFrog.Create;
begin
  FColor := clYellow;
  Randomize;
  SetPosition(Point(Random(30) * 10, Random(30) * 10)); //--> peut apparaitre sur le serpent.
end;

destructor TFrog.destroy;
begin
end;

procedure TFrog.Draw(Canvas: TCanvas);
begin
  Canvas.Brush.Color := Self.FColor;
  FWidth := 10;
  FHeight := 10;
  Canvas.FillRect(Bounds(Position.x, Position.Y, FWidth, FHeight));
end;


procedure TFrog.Move;
begin
  //DO NOTHING
end;

procedure TFrog.Setposition(const Value: TPoint);
begin
  Fposition := Value;
end;



{ TEntityManager-------------------------------------------------------------------- }

function TEntityManager.Add(AObject: TObject): Integer;
begin
  Result := FEntity.Add(AObject);
  Inc(FCount);
end;

constructor TEntityManager.Create;
begin
  FCount := 0;
  FEntity := TObjectList.Create(False);
end;

destructor TEntityManager.Destroy;
begin
  FEntity.Clear;
  Fentity.Free;
end;

function TEntityManager.DoCollision(Serpent: TSerpent): boolean;
var
  I: Integer;
begin
  Result := False;

  {Collision bordure }
  if Serpent <> nil then
  begin
   if (Serpent.Position.x < 0) or (Serpent.Position.x + Serpent.FWidth  > Form1.PB.Width)
   or (Serpent.Position.y < 0) or (Serpent.Position.y + Serpent.FHeight > Form1.PB.Height) then
   begin
     Form1.isGameOver := True;
     GameManager.Stop;
     Result := True;
   end;
  end;

  {collision Serpent-Grenouille}
  if FEntity.Count > 0 then
  for I :=0 to FEntity.Count -1 do
  begin
    if FEntity.Items[I] is TFrog then
    begin
      with FEntity.Items[I] as TFrog do
      begin
        if (position.x = Serpent.Position.x)and
           (Position.y = Serpent.Position.Y) then
        begin
          Windows.Beep(600, 100);
          Form1.isGameOver := False;
          FEntity.Delete(I);
          FreeAndNil(Frog);
          Serpent.SetSize(Serpent.Size + 3);
          Serpent.FCompteur := 3;
          Serpent.Draw(Form1.PB.Canvas);
          Inc(Counter);
        end;
      end;
    end;
  end;
  {collision Serpent-Serpent}
  For I := 1 to Serpent.FItems.Count -1 do
  begin
    if (Serpent.Position.x = PPoint(Serpent.FItems[I])^.x) and
       (Serpent.Position.y = PPoint(Serpent.FItems[I])^.y) then
    begin
       Form1.isGameOver := True;
       GameManager.Stop;
       Result := True;
    end;
  end;
end;

{ TGameManager }

constructor TGameManager.Create;
begin

end;

destructor TGameManager.destroy;
begin

end;

procedure TGameManager.Pause;
begin

end;

procedure TGameManager.Start;
begin
 Serpent := TSerpent.Create;
 Frog := TFrog.Create;
 EntityManager := TEntityManager.Create;
 EntityManager.Add(Frog);
 Form1.Paint;
 Form1.isGameOver := False;
 Form1.Timer1.enabled :=True;
 Counter := 0;
end;

procedure TGameManager.Stop;
begin
  Windows.Beep(110, 500);
  Form1.Timer1.Enabled := False;
  SetBkMode(Form1.PB.Canvas.Handle, TRANSPARENT);
  Form1.PB.Canvas.Font.Size := 18;
  Form1.PB.Canvas.TextOut(100,100,'Game Over !');
  if Serpent <> nil then FreeAndNil(Serpent);
  if Frog <> nil then Frog.Free;
  if EntityManager <> nil then EntityManager.Free;
end;



{  INTERFACE--------------------------------------------------------------------------}

procedure TForm1.FormCreate(Sender: TObject);
begin
  KeyPreview := True;
  isGameOver := False;
  GameManager := TGameManager.Create;
  PB.Width := 300;
  PB.Height := 300;
  doublebuffered := True;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  inherited;
  PB.Canvas.Brush.Color := $00BF0060;
  PB.Canvas.FillRect(PB.ClientRect);
  PB.Canvas.Pen.Color := clGray;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin

  if Assigned(GameManager) then
    GameManager.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ClearPB(PB.Canvas, $00BF0060, PB.ClientRect);
  GameManager.Start;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
//var ISFrogOnSerpent: Boolean;
begin
  ClearPB(PB.Canvas, $00BF0060
  , PB.ClientRect);
  Serpent.Move(Serpent.FKey);
  Serpent.Draw(PB.Canvas);

  if EntityManager.DoCollision(Serpent) then
  begin
    isGameOver := True;
    Timer1.Enabled := False;
  end
  else
  begin
    if Frog <> nil then
      Frog.Draw(PB.Canvas)
    else
    begin
        //ISFrogOnSerpent := False;
        Frog := TFrog.Create;
        {Repeat
        begin
        for I := 0 to Serpent.FItems.Count -1 do
        begin
          if (Frog.position.x = PPoint(Serpent.FItems[I])^.x) or
            (Frog.position.y = PPoint(Serpent.FItems[i])^.Y) then
          begin
            ISFrogOnSerpent := True;
            Break;
          end
        end;
      end
      until ISFrogOnSerpent = False;   }
      EntityManager.Add(Frog);
    end;
  end;
  Form1.Label1.Caption := IntToStr(Counter);
  Form1.Label2.Caption := 'Score:';
end;

procedure TForm1.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
begin
  if Msg.Message = WM_KEYDOWN then
    if not isGameOver then
      Case  Msg.wparam of
        VK_LEFT  : Serpent.FKey := toLeft;
        VK_RIGHT : Serpent.FKey := toRight;
        VK_UP    : Serpent.FKey := toUp;
        VK_DOWN  : Serpent.FKey := toDown;
         //VK_PAUSE : SnakePause(GameEvent,PauseLAbel,GameZone);    // non implement
      end;
end;



Initialization
  RegisterCLasses([TFrog]);  // inutile finalement pas de serialisation pour sauvegarde en cours.

end.
